﻿using System;
using Celeste.Mod.Entities;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Threading.Tasks;
using System.Windows.Input;
using System.Data;
using System.Collections.Generic;
using Celeste;
using Microsoft.Xna.Framework;
using Monocle;
using Celeste.Mod.UI;
using System.Runtime.CompilerServices;
using Microsoft.Xna.Framework.Input;
using On.Monocle;

namespace Celeste.Mod.APMmeter;

public class APMmeterModule : EverestModule {
    public static APMmeterModule Instance { get; private set; }

    public override Type SettingsType => typeof(APMmeterModuleSettings);
    public static APMmeterModuleSettings Settings => (APMmeterModuleSettings)Instance._Settings;

    public override Type SessionType => typeof(APMmeterModuleSession);
    public static APMmeterModuleSession Session => (APMmeterModuleSession)Instance._Session;

    public override Type SaveDataType => typeof(APMmeterModuleSaveData);
    public static APMmeterModuleSaveData SaveData => (APMmeterModuleSaveData)Instance._SaveData;

    public APMmeterModule() {
        Instance = this;
#if DEBUG
        // debug builds use verbose logging
        Logger.SetLogLevel(nameof(APMmeterModule), LogLevel.Verbose);
#else
        // release builds use info logging to reduce spam in log files
        Logger.SetLogLevel(nameof(APMmeterModule), LogLevel.Info);
#endif
    }    
    private static void OnLoadingThread(Level level)
    {
        level.Add(new Display());
    }
    public override void Load() 
    {
        Everest.Events.LevelLoader.OnLoadingThread += OnLoadingThread;
    }

    public override void Unload() 
    {
        Everest.Events.LevelLoader.OnLoadingThread -= OnLoadingThread;
    }
}